diff --git a/common/Makefile b/common/Makefile
index 17f043b2357..94d4aa2dbca 100644
--- a/common/Makefile
+++ b/common/Makefile
@@ -42,6 +42,7 @@ COMMON_SRC_NOGEN :=				\
 	common/utils.c				\
 	common/utxo.c				\
 	common/version.c			\
+	common/wallet_tx.c			\
 	common/wireaddr.c			\
 	common/wire_error.c			\
 	common/withdraw_tx.c
diff --git a/common/wallet_tx.c b/common/wallet_tx.c
new file mode 100644
index 00000000000..9a46831637c
--- /dev/null
+++ b/common/wallet_tx.c
@@ -0,0 +1,66 @@
+#include <common/wallet_tx.h>
+#include <inttypes.h>
+#include <lightningd/jsonrpc_errors.h>
+#include <wallet/wallet.h>
+
+void wtx_init(struct command *cmd, struct wallet_tx * wtx)
+{
+	wtx->cmd = cmd;
+	wtx->amount = 0;
+	wtx->change_key_index = 0;
+	wtx->utxos = NULL;
+	wtx->all_funds = false;
+	wtx->desttok = NULL;
+}
+
+bool wtx_json_get_params(struct wallet_tx * tx, const char * buffer,
+	            const jsmntok_t *params, const char * dest)
+{
+	const jsmntok_t * sattok;
+
+	if (!json_get_params(tx->cmd, buffer, params, dest,
+			     &tx->desttok, "satoshi", &sattok, NULL))
+		return false;
+	if (json_tok_streq(buffer, sattok, "all")) {
+		tx->all_funds = true;
+	} else if (!json_tok_u64(buffer, sattok, &tx->amount)) {
+		command_fail(tx->cmd, "Invalid satoshis");
+		return false;
+	}
+	return true;
+}
+
+bool wtx_select_utxos(struct wallet_tx * tx, u32 fee_rate_per_kw,
+	              size_t out_len)
+{
+	u64 fee_estimate;
+	if (tx->all_funds) {
+		tx->utxos = wallet_select_all(tx->cmd, tx->cmd->ld->wallet,
+					      fee_rate_per_kw, out_len,
+					      &tx->amount,
+					      &fee_estimate);
+		if (!tx->utxos || tx->amount < 546) {
+			command_fail(tx->cmd, "Cannot afford fee %"PRIu64,
+				     fee_estimate);
+			return false;
+		}
+		tx->change = 0;
+	} else {
+		tx->utxos = wallet_select_coins(tx->cmd, tx->cmd->ld->wallet,
+						tx->amount,
+						fee_rate_per_kw, out_len,
+						&fee_estimate, &tx->change);
+		if (!tx->utxos || tx->amount < 546) {
+			command_fail(tx->cmd,
+			"Cannot afford funding transaction");
+			return false;
+		}
+		if (tx->change < 546) {
+			tx->change = 0;
+			tx->change_key_index = 0;
+		} else {
+			tx->change_key_index = wallet_get_newindex(tx->cmd->ld);
+		}
+	}
+	return true;
+}
diff --git a/common/wallet_tx.h b/common/wallet_tx.h
new file mode 100644
index 00000000000..f97f8f67981
--- /dev/null
+++ b/common/wallet_tx.h
@@ -0,0 +1,28 @@
+#ifndef LIGHTNING_COMMON_WALLET_TX_H
+#define LIGHTNING_COMMON_WALLET_TX_H
+#include "config.h"
+#include <ccan/short_types/short_types.h>
+#include <lightningd/json.h>
+#include <lightningd/jsonrpc.h>
+#include <lightningd/lightningd.h>
+
+/* A specification of funds in the wallet used for funding channels and
+ * withdrawal.
+ */
+struct wallet_tx {
+	struct command *cmd;
+	u64 amount;
+	u64 change;
+	u32 change_key_index;
+	const struct utxo **utxos;
+
+	bool all_funds;
+	const jsmntok_t *desttok;
+};
+
+void wtx_init(struct command *cmd, struct wallet_tx *wtx);
+bool wtx_json_get_params(struct wallet_tx * tx, const char * buffer,
+		    const jsmntok_t *params, const char * dest);
+bool wtx_select_utxos(struct wallet_tx * tx, u32 fee_rate_per_kw,
+		      size_t out_len);
+#endif /* LIGHTNING_COMMON_WALLET_TX_H */
diff --git a/lightningd/Makefile b/lightningd/Makefile
index d93ea956b53..0615a70a353 100644
--- a/lightningd/Makefile
+++ b/lightningd/Makefile
@@ -44,13 +44,13 @@ LIGHTNINGD_COMMON_OBJS :=			\
 	common/utils.o				\
 	common/utxo.o				\
 	common/version.o			\
+	common/wallet_tx.o			\
 	common/wire_error.o			\
 	common/wireaddr.o			\
 	common/withdraw_tx.o
 
 LIGHTNINGD_SRC :=				\
 	lightningd/bitcoind.c			\
-	lightningd/build_utxos.c		\
 	lightningd/chaintopology.c		\
 	lightningd/channel.c			\
 	lightningd/channel_control.c		\
diff --git a/lightningd/build_utxos.c b/lightningd/build_utxos.c
deleted file mode 100644
index e52d5694379..00000000000
--- a/lightningd/build_utxos.c
+++ /dev/null
@@ -1,34 +0,0 @@
-#include <bitcoin/base58.h>
-#include <bitcoin/script.h>
-#include <ccan/structeq/structeq.h>
-#include <common/utils.h>
-#include <lightningd/build_utxos.h>
-#include <lightningd/jsonrpc.h>
-#include <wally_bip32.h>
-
-
-const struct utxo **build_utxos(const tal_t *ctx,
-				struct lightningd *ld, u64 satoshi_out,
-				u32 feerate_per_kw, u64 dust_limit,
-				size_t outputscriptlen,
-				u64 *change_satoshis, u32 *change_keyindex)
-{
-	u64 fee_estimate = 0;
-	const struct utxo **utxos =
-	    wallet_select_coins(ctx, ld->wallet, satoshi_out, feerate_per_kw,
-				outputscriptlen,
-				&fee_estimate, change_satoshis);
-
-	/* Oops, didn't have enough coins available */
-	if (!utxos)
-		return NULL;
-
-	/* Do we need a change output? */
-	if (*change_satoshis < dust_limit) {
-		*change_satoshis = 0;
-		*change_keyindex = 0;
-	} else {
-		*change_keyindex = wallet_get_newindex(ld);
-	}
-	return utxos;
-}
diff --git a/lightningd/build_utxos.h b/lightningd/build_utxos.h
deleted file mode 100644
index 305d8906750..00000000000
--- a/lightningd/build_utxos.h
+++ /dev/null
@@ -1,15 +0,0 @@
-#ifndef LIGHTNING_LIGHTNINGD_BUILD_UTXOS_H
-#define LIGHTNING_LIGHTNINGD_BUILD_UTXOS_H
-#include "config.h"
-#include <common/utxo.h>
-#include <lightningd/lightningd.h>
-
-/* Reserves UTXOs to build tx which pays this amount; returns NULL if
- * impossible. */
-const struct utxo **build_utxos(const tal_t *ctx,
-				struct lightningd *ld, u64 satoshi_out,
-				u32 feerate_per_kw, u64 dust_limit,
-				size_t outputscriptlen,
-				u64 *change_satoshis, u32 *change_keyindex);
-
-#endif /* LIGHTNING_LIGHTNINGD_BUILD_UTXOS_H */
diff --git a/lightningd/opening_control.c b/lightningd/opening_control.c
index b5434db78f3..d11ac352623 100644
--- a/lightningd/opening_control.c
+++ b/lightningd/opening_control.c
@@ -4,11 +4,11 @@
 #include <common/channel_config.h>
 #include <common/funding_tx.h>
 #include <common/key_derive.h>
+#include <common/wallet_tx.h>
 #include <common/wire_error.h>
 #include <errno.h>
 #include <gossipd/gen_gossip_wire.h>
 #include <hsmd/gen_hsm_client_wire.h>
-#include <lightningd/build_utxos.h>
 #include <lightningd/chaintopology.h>
 #include <lightningd/channel_control.h>
 #include <lightningd/closing_control.h>
@@ -24,6 +24,7 @@
 #include <wire/wire.h>
 #include <wire/wire_sync.h>
 
+
 /* Channel we're still opening. */
 struct uncommitted_channel {
 	/* peer->uncommitted_channel == this */
@@ -60,22 +61,19 @@ struct uncommitted_channel {
 	struct channel_config our_config;
 };
 
+
 struct funding_channel {
 	/* In lightningd->fundchannels while waiting for gossipd reply. */
 	struct list_node list;
 
 	struct command *cmd; /* Which also owns us. */
+	struct wallet_tx wtx;
+	u64 push_msat;
+	u8 channel_flags;
 
 	/* Peer we're trying to reach. */
 	struct pubkey peerid;
 
-	/* Details of how to make funding. */
-	const struct utxo **utxomap;
-	u64 change;
-	u32 change_keyindex;
-	u64 funding_satoshi, push_msat;
-	u8 channel_flags;
-
 	/* Channel. */
 	struct uncommitted_channel *uc;
 };
@@ -161,7 +159,7 @@ void json_add_uncommitted_channel(struct json_result *response,
 	if (uc->fc) {
 		u64 msatoshi_total, our_msatoshi;
 
-		msatoshi_total = uc->fc->funding_satoshi * 1000;
+		msatoshi_total = uc->fc->wtx.amount * 1000;
 		our_msatoshi = msatoshi_total - uc->fc->push_msat;
 		json_add_u64(response, "msatoshi_to_us", our_msatoshi);
 		json_add_u64(response, "msatoshi_total", msatoshi_total);
@@ -309,18 +307,18 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 				       &channel_info.remote_per_commit));
 
 	/* Generate the funding tx. */
-	if (fc->change
+	if (fc->wtx.change
 	    && !bip32_pubkey(ld->wallet->bip32_base,
-			     &changekey, fc->change_keyindex))
-		fatal("Error deriving change key %u", fc->change_keyindex);
+			     &changekey, fc->wtx.change_key_index))
+		fatal("Error deriving change key %u", fc->wtx.change_key_index);
 
 	derive_basepoints(&fc->uc->seed, &local_fundingkey, NULL, NULL, NULL);
 
 	fundingtx = funding_tx(tmpctx, &funding_outnum,
-			       fc->utxomap, fc->funding_satoshi,
+			       fc->wtx.utxos, fc->wtx.amount,
 			       &local_fundingkey,
 			       &channel_info.remote_fundingkey,
-			       fc->change, &changekey,
+			       fc->wtx.change, &changekey,
 			       ld->wallet->bip32_base);
 
 	log_debug(fc->uc->log, "Funding tx has %zi inputs, %zu outputs:",
@@ -329,8 +327,8 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 
 	for (size_t i = 0; i < tal_count(fundingtx->input); i++) {
 		log_debug(fc->uc->log, "%zi: %"PRIu64" satoshi (%s) %s\n",
-			  i, fc->utxomap[i]->amount,
-			  fc->utxomap[i]->is_p2sh ? "P2SH" : "SEGWIT",
+			  i, fc->wtx.utxos[i]->amount,
+			  fc->wtx.utxos[i]->is_p2sh ? "P2SH" : "SEGWIT",
 			  type_to_string(tmpctx, struct bitcoin_txid,
 					 &fundingtx->input[i].txid));
 	}
@@ -343,8 +341,8 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 			   " satoshi %"PRIu64" change %"PRIu64
 			   " changeidx %u"
 			   " localkey %s remotekey %s",
-			   fc->funding_satoshi,
-			   fc->change, fc->change_keyindex,
+			   fc->wtx.amount,
+			   fc->wtx.change, fc->wtx.change_key_index,
 			   type_to_string(fc, struct pubkey,
 					  &local_fundingkey),
 			   type_to_string(fc, struct pubkey,
@@ -354,8 +352,8 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 			     " satoshi %"PRIu64" change %"PRIu64
 			     " changeidx %u"
 			     " localkey %s remotekey %s",
-			     fc->funding_satoshi,
-			     fc->change, fc->change_keyindex,
+			     fc->wtx.amount,
+			     fc->wtx.change, fc->wtx.change_key_index,
 			     type_to_string(fc, struct pubkey,
 					    &local_fundingkey),
 			     type_to_string(fc, struct pubkey,
@@ -369,7 +367,7 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 					&remote_commit_sig,
 					&funding_txid,
 					funding_outnum,
-					fc->funding_satoshi,
+					fc->wtx.amount,
 					fc->push_msat,
 					fc->channel_flags,
 					&channel_info,
@@ -383,10 +381,10 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 	log_debug(channel->log, "Getting HSM to sign funding tx");
 
 	msg = towire_hsm_sign_funding(tmpctx, channel->funding_satoshi,
-				      fc->change, fc->change_keyindex,
+				      fc->wtx.change, fc->wtx.change_key_index,
 				      &local_fundingkey,
 				      &channel_info.remote_fundingkey,
-				      fc->utxomap);
+				      fc->wtx.utxos);
 
 	if (!wire_sync_write(ld->hsm_fd, take(msg)))
 		fatal("Could not write to HSM: %s", strerror(errno));
@@ -414,7 +412,7 @@ static void opening_funder_finished(struct subd *openingd, const u8 *resp,
 	peer_start_channeld(channel, &cs, gossip_index,
 			    fds[0], fds[1], NULL, false);
 
-	wallet_confirm_utxos(ld->wallet, fc->utxomap);
+	wallet_confirm_utxos(ld->wallet, fc->wtx.utxos);
 
 	response = new_json_result(fc->cmd);
 	json_object_start(response, NULL);
@@ -806,13 +804,13 @@ static void peer_offer_channel(struct lightningd *ld,
 				  cs, gossip_index, &fc->uc->seed);
 	subd_send_msg(fc->uc->openingd, take(msg));
 
-	msg = towire_opening_funder(fc, fc->funding_satoshi,
+	msg = towire_opening_funder(fc, fc->wtx.amount,
 				    fc->push_msat,
 				    get_feerate(ld->topology, FEERATE_NORMAL),
 				    max_minimum_depth,
-				    fc->change, fc->change_keyindex,
+				    fc->wtx.change, fc->wtx.change_key_index,
 				    fc->channel_flags,
-				    fc->utxomap,
+				    fc->wtx.utxos,
 				    ld->wallet->bip32_base);
 
 	subd_req(fc, fc->uc->openingd,
@@ -895,68 +893,25 @@ bool handle_opening_channel(struct lightningd *ld,
 static void json_fund_channel(struct command *cmd,
 			      const char *buffer, const jsmntok_t *params)
 {
-	jsmntok_t *desttok, *sattok;
-	bool all_funds = false;
-	struct funding_channel * fc;
+	struct funding_channel * fc = tal(cmd, struct funding_channel);
 	u32 feerate_per_kw = get_feerate(cmd->ld->topology, FEERATE_NORMAL);
-	u64 fee_estimate;
 	u8 *msg;
 
-	if (!json_get_params(cmd, buffer, params,
-			     "id", &desttok,
-			     "satoshi", &sattok,
-			     NULL)) {
-		return;
-	}
-
-	fc = tal(cmd, struct funding_channel);
-	fc->uc = NULL;
 	fc->cmd = cmd;
-	fc->change_keyindex = 0;
-	fc->funding_satoshi = 0;
-
-	if (json_tok_streq(buffer, sattok, "all")) {
-		all_funds = true;
-	} else if (!json_tok_u64(buffer, sattok, &fc->funding_satoshi)) {
-		command_fail(cmd, "Invalid satoshis");
+	fc->uc = NULL;
+	wtx_init(cmd, &fc->wtx);
+	if (!wtx_json_get_params(&fc->wtx, buffer, params, "id"))
 		return;
-	}
 
-	if (!pubkey_from_hexstr(buffer + desttok->start,
-				desttok->end - desttok->start, &fc->peerid)) {
-		command_fail(cmd, "Could not parse id");
-		return;
-	}
 	/* FIXME: Support push_msat? */
 	fc->push_msat = 0;
 	fc->channel_flags = OUR_CHANNEL_FLAGS;
 
-	/* Try to do this now, so we know if insufficient funds. */
-	/* FIXME: dustlimit */
-	if (all_funds) {
-		fc->utxomap = wallet_select_all(cmd, cmd->ld->wallet,
-			feerate_per_kw,
-			BITCOIN_SCRIPTPUBKEY_P2WSH_LEN,
-			&fc->funding_satoshi,
-			&fee_estimate);
-		if (!fc->utxomap || fc->funding_satoshi < 546) {
-			command_fail(cmd, "Cannot afford fee %"PRIu64,
-				     fee_estimate);
-			return;
-		}
-		fc->change = 0;
-	} else {
-		fc->utxomap = build_utxos(fc, cmd->ld, fc->funding_satoshi,
-			feerate_per_kw,
-			600, BITCOIN_SCRIPTPUBKEY_P2WSH_LEN,
-			&fc->change, &fc->change_keyindex);
-		if (!fc->utxomap) {
-			command_fail(cmd, "Cannot afford funding transaction");
-			return;
-		}
-	}
+	if (!wtx_select_utxos(&fc->wtx, feerate_per_kw,
+			      BITCOIN_SCRIPTPUBKEY_P2WSH_LEN))
+		return;
 
-	if (fc->funding_satoshi > MAX_FUNDING_SATOSHI) {
+	if (fc->wtx.amount > MAX_FUNDING_SATOSHI) {
 		command_fail(cmd, "Funding satoshi must be <= %d",
 			     MAX_FUNDING_SATOSHI);
 		return;
@@ -965,6 +920,12 @@ static void json_fund_channel(struct command *cmd,
 	list_add(&cmd->ld->fundchannels, &fc->list);
 	tal_add_destructor(fc, remove_funding_channel_from_list);
 
+	if (!pubkey_from_hexstr(buffer + fc->wtx.desttok->start,
+				fc->wtx.desttok->end - fc->wtx.desttok->start,
+				&fc->peerid)) {
+		command_fail(cmd, "Could not parse id");
+		return;
+	}
 	msg = towire_gossipctl_release_peer(cmd, &fc->peerid);
 	subd_req(fc, cmd->ld->gossip, msg, -1, 2, gossip_peer_released, fc);
 	command_still_pending(cmd);
diff --git a/lightningd/peer_control.c b/lightningd/peer_control.c
index ae74e54e9da..8521509adb3 100644
--- a/lightningd/peer_control.c
+++ b/lightningd/peer_control.c
@@ -26,7 +26,6 @@
 #include <hsmd/gen_hsm_client_wire.h>
 #include <inttypes.h>
 #include <lightningd/bitcoind.h>
-#include <lightningd/build_utxos.h>
 #include <lightningd/chaintopology.h>
 #include <lightningd/channel_control.h>
 #include <lightningd/closing_control.h>
diff --git a/wallet/walletrpc.c b/wallet/walletrpc.c
index 123a5d0a902..e547062c9cd 100644
--- a/wallet/walletrpc.c
+++ b/wallet/walletrpc.c
@@ -6,6 +6,7 @@
 #include <common/key_derive.h>
 #include <common/status.h>
 #include <common/utxo.h>
+#include <common/wallet_tx.h>
 #include <common/withdraw_tx.h>
 #include <errno.h>
 #include <hsmd/gen_hsm_client_wire.h>
@@ -23,11 +24,9 @@
 #include <wire/wire_sync.h>
 
 struct withdrawal {
-	u64 amount, changesatoshi;
-	u8 *destination;
-	const struct utxo **utxos;
-	u64 change_key_index;
 	struct command *cmd;
+	struct wallet_tx wtx;
+	u8 *destination;
 	const char *hextx;
 };
 
@@ -52,7 +51,7 @@ static void wallet_withdrawal_broadcast(struct bitcoind *bitcoind UNUSED,
 	char *output = tal_strjoin(cmd, tal_strsplit(cmd, msg, "\n", STR_NO_EMPTY), " ", STR_NO_TRAIL);
 	if (exitstatus == 0) {
 		/* Mark used outputs as spent */
-		wallet_confirm_utxos(ld->wallet, withdraw->utxos);
+		wallet_confirm_utxos(ld->wallet, withdraw->wtx.utxos);
 
 		/* Parse the tx and extract the change output. We
 		 * generated the hex tx, so this should always work */
@@ -60,9 +59,9 @@ static void wallet_withdrawal_broadcast(struct bitcoind *bitcoind UNUSED,
 		assert(tx != NULL);
 		wallet_extract_owned_outputs(ld->wallet, tx, NULL, &change_satoshi);
 
-		/* Note normally, change_satoshi == withdraw->changesatoshi, but
+		/* Note normally, change_satoshi == withdraw->wtx.change, but
 		 * not if we're actually making a payment to ourselves! */
-		assert(change_satoshi >= withdraw->changesatoshi);
+		assert(change_satoshi >= withdraw->wtx.change);
 
 		struct json_result *response = new_json_result(cmd);
 		json_object_start(response, NULL);
@@ -85,35 +84,22 @@ static void wallet_withdrawal_broadcast(struct bitcoind *bitcoind UNUSED,
 static void json_withdraw(struct command *cmd,
 			  const char *buffer, const jsmntok_t *params)
 {
-	jsmntok_t *desttok, *sattok;
-	struct withdrawal *withdraw;
+	struct withdrawal *withdraw = tal(cmd, struct withdrawal);
+
 	u32 feerate_per_kw = get_feerate(cmd->ld->topology, FEERATE_NORMAL);
-	u64 fee_estimate;
 	struct bitcoin_tx *tx;
-	bool all_funds = false;
-	enum address_parse_result addr_parse;
 
-	if (!json_get_params(cmd, buffer, params,
-			     "destination", &desttok,
-			     "satoshi", &sattok,
-			     NULL)) {
-		return;
-	}
+	enum address_parse_result addr_parse;
 
-	withdraw = tal(cmd, struct withdrawal);
 	withdraw->cmd = cmd;
-
-	if (json_tok_streq(buffer, sattok, "all"))
-		all_funds = true;
-	else if (!json_tok_u64(buffer, sattok, &withdraw->amount)) {
-		command_fail(cmd, "Invalid satoshis");
+	wtx_init(cmd, &withdraw->wtx);
+	if (!wtx_json_get_params(&withdraw->wtx, buffer, params, "destination"))
 		return;
-	}
 
 	/* Parse address. */
 	addr_parse = json_tok_address_scriptpubkey(cmd,
 						   get_chainparams(cmd->ld),
-						   buffer, desttok,
+						   buffer, withdraw->wtx.desttok,
 						   (const u8**)(&withdraw->destination));
 
 	/* Check that destination address could be understood. */
@@ -125,53 +111,21 @@ static void json_withdraw(struct command *cmd,
 	/* Check address given is compatible with the chain we are on. */
 	if (addr_parse == ADDRESS_PARSE_WRONG_NETWORK) {
 		command_fail(cmd,
-			    "Destination address is not on network %s",
-			    get_chainparams(cmd->ld)->network_name);
+			     "Destination address is not on network %s",
+			     get_chainparams(cmd->ld)->network_name);
 		return;
 	}
 
-	/* Select the coins */
-	if (all_funds) {
-		withdraw->utxos = wallet_select_all(cmd, cmd->ld->wallet,
-						    feerate_per_kw,
-						    tal_len(withdraw->destination),
-						    &withdraw->amount,
-						    &fee_estimate);
-		/* FIXME Pull dust amount from the daemon config */
-		if (!withdraw->utxos || withdraw->amount < 546) {
-			command_fail(cmd, "Cannot afford fee %"PRIu64,
-				     fee_estimate);
-			return;
-		}
-		withdraw->changesatoshi = 0;
-	} else {
-		withdraw->utxos = wallet_select_coins(cmd, cmd->ld->wallet,
-						      withdraw->amount,
-						      feerate_per_kw,
-						      tal_len(withdraw->destination),
-						      &fee_estimate,
-						      &withdraw->changesatoshi);
-		if (!withdraw->utxos) {
-			command_fail(cmd, "Not enough funds available");
-			return;
-		}
-	}
-
-	/* FIXME(cdecker) Pull this from the daemon config */
-	if (withdraw->changesatoshi <= 546)
-		withdraw->changesatoshi = 0;
-
-	if (withdraw->changesatoshi)
-		withdraw->change_key_index = wallet_get_newindex(cmd->ld);
-	else
-		withdraw->change_key_index = 0;
+	if (!wtx_select_utxos(&withdraw->wtx, feerate_per_kw,
+			      tal_len(withdraw->destination)))
+		return;
 
 	u8 *msg = towire_hsm_sign_withdrawal(cmd,
-					     withdraw->amount,
-					     withdraw->changesatoshi,
-					     withdraw->change_key_index,
+					     withdraw->wtx.amount,
+					     withdraw->wtx.change,
+					     withdraw->wtx.change_key_index,
 					     withdraw->destination,
-					     withdraw->utxos);
+					     withdraw->wtx.utxos);
 
 	if (!wire_sync_write(cmd->ld->hsm_fd, take(msg)))
 		fatal("Could not write sign_withdrawal to HSM: %s",
